## fftw3 3.3.7

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (fftw)

if (POLICY CMP0042)
  cmake_policy (SET CMP0042 NEW)
endif ()

option (BUILD_SHARED_LIBS "Build shared libraries" ON)
option (BUILD_TESTS "Build tests" ON)

option (ENABLE_OPENMP "Use OpenMP for multithreading" OFF)
option (ENABLE_THREADS "Use pthread for multithreading" OFF)
option (WITH_COMBINED_THREADS "Merge thread library" OFF)

option (ENABLE_FLOAT "single-precision" OFF)
option (ENABLE_LONG_DOUBLE "long-double precision" OFF)
option (ENABLE_QUAD_PRECISION "quadruple-precision" OFF)

option (ENABLE_SSE "Compile with SSE instruction set support" OFF)
option (ENABLE_SSE2 "Compile with SSE2 instruction set support" OFF)
option (ENABLE_AVX "Compile with AVX instruction set support" OFF)
option (ENABLE_AVX2 "Compile with AVX2 instruction set support" OFF)

include(GNUInstallDirs)


include (CheckIncludeFile)
check_include_file (alloca.h         HAVE_ALLOCA_H)
check_include_file (altivec.h        HAVE_ALTIVEC_H)
check_include_file (c_asm.h          HAVE_C_ASM_H)
check_include_file (intrinsics.h     HAVE_INTRINSICS_H)
check_include_file (inttypes.h       HAVE_INTTYPES_H)
check_include_file (libintl.h        HAVE_LIBINTL_H)
check_include_file (limits.h         HAVE_LIMITS_H)
check_include_file (mach/mach_time.h HAVE_MACH_MACH_TIME_H)
check_include_file (malloc.h         HAVE_MALLOC_H)
check_include_file (memory.h         HAVE_MEMORY_H)
check_include_file (stddef.h         HAVE_STDDEF_H)
check_include_file (stdint.h         HAVE_STDINT_H)
check_include_file (stdlib.h         HAVE_STDLIB_H)
check_include_file (string.h         HAVE_STRING_H)
check_include_file (strings.h        HAVE_STRINGS_H)
check_include_file (sys/types.h      HAVE_SYS_TYPES_H)
check_include_file (sys/time.h       HAVE_SYS_TIME_H)
check_include_file (sys/stat.h       HAVE_SYS_STAT_H)
check_include_file (sys/sysctl.h     HAVE_SYS_SYSCTL_H)
check_include_file (time.h           HAVE_TIME_H)
check_include_file (uintptr.h        HAVE_UINTPTR_H)
check_include_file (unistd.h         HAVE_UNISTD_H)
if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set (TIME_WITH_SYS_TIME TRUE)
endif ()

include (CheckPrototypeDefinition) 
check_prototype_definition (drand48 "double drand48 (void)" "0" stdlib.h HAVE_DECL_DRAND48)
check_prototype_definition (srand48 "void srand48(long int seedval)" "0" stdlib.h HAVE_DECL_SRAND48)
check_prototype_definition (cosl "long double cosl( long double arg )" "0" math.h HAVE_DECL_COSL)
check_prototype_definition (sinl "long double sinl( long double arg )" "0" math.h HAVE_DECL_SINL)
check_prototype_definition (memalign "void *memalign(size_t alignment, size_t size)" "0" malloc.h HAVE_DECL_MEMALIGN)
check_prototype_definition (posix_memalign "int posix_memalign(void **memptr, size_t alignment, size_t size)" "0" stdlib.h HAVE_DECL_POSIX_MEMALIGN)

include (CheckSymbolExists)
check_symbol_exists (clock_gettime time.h HAVE_CLOCK_GETTIME)
check_symbol_exists (gettimeofday sys/time.h HAVE_GETTIMEOFDAY)
check_symbol_exists (drand48 stdlib.h HAVE_DRAND48)
check_symbol_exists (srand48 stdlib.h HAVE_SRAND48)
check_symbol_exists (memalign malloc.h HAVE_MEMALIGN)
check_symbol_exists (posix_memalign stdlib.h HAVE_POSIX_MEMALIGN)
check_symbol_exists (mach_absolute_time mach/mach_time.h HAVE_MACH_ABSOLUTE_TIME)
check_symbol_exists (alloca alloca.h HAVE_ALLOCA)
check_symbol_exists (isnan math.h HAVE_ISNAN)
check_symbol_exists (snprintf stdio.h HAVE_SNPRINTF)

if (UNIX)
  set (CMAKE_REQUIRED_LIBRARIES m)
endif ()
check_symbol_exists (cosl math.h HAVE_COSL)
check_symbol_exists (sinl math.h HAVE_SINL)

include (CheckTypeSize)
check_type_size ("float" SIZEOF_FLOAT)
check_type_size ("double" SIZEOF_DOUBLE)
check_type_size ("int" SIZEOF_INT)
check_type_size ("long" SIZEOF_LONG)
check_type_size ("long long" SIZEOF_LONG_LONG)
check_type_size ("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size ("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size ("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
check_type_size ("size_t" SIZEOF_SIZE_T)
check_type_size ("ptrdiff_t" SIZEOF_PTRDIFF_T)

if (UNIX)
  set (HAVE_LIBM TRUE)
endif ()


if (ENABLE_THREADS)
  find_package (Threads)
endif ()
if (Threads_FOUND)
  if(CMAKE_USE_PTHREADS_INIT)
    set (USING_POSIX_THREADS 1)
  endif ()
  set (HAVE_THREADS TRUE)
endif ()

if (ENABLE_OPENMP)
  find_package (OpenMP)
endif ()
if (OPENMP_FOUND)
  set (HAVE_OPENMP TRUE)
endif ()

include (CheckCCompilerFlag)

if (ENABLE_SSE)
  foreach (FLAG "-msse" "/arch:SSE")
    unset (HAVE_SSE CACHE)
    check_c_compiler_flag (${FLAG} HAVE_SSE)
    if (HAVE_SSE)
      set (SSE_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_SSE2)
  foreach (FLAG "-msse2" "/arch:SSE2")
    unset (HAVE_SSE2 CACHE)
    check_c_compiler_flag (${FLAG} HAVE_SSE2)
    if (HAVE_SSE2)
      set (SSE2_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_AVX)
  foreach (FLAG "-mavx" "/arch:AVX")
    unset (HAVE_AVX CACHE)
    check_c_compiler_flag (${FLAG} HAVE_AVX)
    if (HAVE_AVX)
      set (AVX_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_AVX2)
  foreach (FLAG "-mavx2" "/arch:AVX2")
    unset (HAVE_AVX2 CACHE)
    check_c_compiler_flag (${FLAG} HAVE_AVX2)
    if (HAVE_AVX2)
      set (AVX2_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

# AVX2 codelets require FMA support as well
if (ENABLE_AVX2)
  foreach (FLAG "-mfma" "/arch:FMA")
    unset (HAVE_FMA CACHE)
    check_c_compiler_flag (${FLAG} HAVE_FMA)
    if (HAVE_FMA)
      set (FMA_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (HAVE_SSE2 OR HAVE_AVX)
  set (HAVE_SIMD TRUE)
endif ()
file(GLOB           fftw_api_SOURCE                 api/*.c             api/*.h)
file(GLOB           fftw_dft_SOURCE                 dft/*.c             dft/*.h)
file(GLOB           fftw_dft_scalar_SOURCE          dft/scalar/*.c      dft/scalar/*.h)
file(GLOB           fftw_dft_scalar_codelets_SOURCE dft/scalar/codelets/*.c     dft/scalar/codelets/*.h)
file(GLOB           fftw_dft_simd_SOURCE            dft/simd/*.c        dft/simd/*.h)

file(GLOB           fftw_dft_simd_sse2_SOURCE       dft/simd/sse2/*.c   dft/simd/sse2/*.h)
file(GLOB           fftw_dft_simd_avx_SOURCE        dft/simd/avx/*.c    dft/simd/avx/*.h)
file(GLOB           fftw_dft_simd_avx2_SOURCE       dft/simd/avx2/*.c   dft/simd/avx2/*.h dft/simd/avx2-128/*.c   dft/simd/avx2-128/*.h)
file(GLOB           fftw_kernel_SOURCE              kernel/*.c          kernel/*.h)
file(GLOB           fftw_rdft_SOURCE                rdft/*.c            rdft/*.h)
file(GLOB           fftw_rdft_scalar_SOURCE         rdft/scalar/*.c     rdft/scalar/*.h)

file(GLOB           fftw_rdft_scalar_r2cb_SOURCE    rdft/scalar/r2cb/*.c
                                                    rdft/scalar/r2cb/*.h)
file(GLOB           fftw_rdft_scalar_r2cf_SOURCE    rdft/scalar/r2cf/*.c
                                                    rdft/scalar/r2cf/*.h)
file(GLOB           fftw_rdft_scalar_r2r_SOURCE     rdft/scalar/r2r/*.c
                                                    rdft/scalar/r2r/*.h)

file(GLOB           fftw_rdft_simd_SOURCE           rdft/simd/*.c       rdft/simd/*.h)
file(GLOB           fftw_rdft_simd_sse2_SOURCE      rdft/simd/sse2/*.c  rdft/simd/sse2/*.h)
file(GLOB           fftw_rdft_simd_avx_SOURCE       rdft/simd/avx/*.c   rdft/simd/avx/*.h)
file(GLOB           fftw_rdft_simd_avx2_SOURCE      rdft/simd/avx2/*.c  rdft/simd/avx2/*.h rdft/simd/avx2-128/*.c  rdft/simd/avx2-128/*.h)

file(GLOB           fftw_reodft_SOURCE              reodft/*.c          reodft/*.h)
file(GLOB           fftw_simd_support_SOURCE        simd-support/*.c    simd-support/*.h)
file(GLOB           fftw_libbench2_SOURCE           libbench2/*.c       libbench2/*.h)
list (REMOVE_ITEM   fftw_libbench2_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/libbench2/useropt.c)

set(SOURCEFILES
    ${fftw_api_SOURCE}
    ${fftw_dft_SOURCE}
    ${fftw_dft_scalar_SOURCE}
    ${fftw_dft_scalar_codelets_SOURCE}
    ${fftw_dft_simd_SOURCE}
    ${fftw_kernel_SOURCE}
    ${fftw_rdft_SOURCE}
    ${fftw_rdft_scalar_SOURCE}

    ${fftw_rdft_scalar_r2cb_SOURCE}
    ${fftw_rdft_scalar_r2cf_SOURCE}
    ${fftw_rdft_scalar_r2r_SOURCE}

    ${fftw_rdft_simd_SOURCE}
    ${fftw_reodft_SOURCE}
    ${fftw_simd_support_SOURCE}
    ${fftw_threads_SOURCE}
)

set(fftw_par_SOURCE
    threads/api.c
    threads/conf.c
    threads/ct.c
    threads/dft-vrank-geq1.c
    threads/f77api.c
    threads/hc2hc.c
    threads/rdft-vrank-geq1.c
    threads/vrank-geq1-rdft2.c)

set (fftw_threads_SOURCE ${fftw_par_SOURCE} threads/threads.c)
set (fftw_omp_SOURCE ${fftw_par_SOURCE} threads/openmp.c)


include_directories (.)


if (WITH_COMBINED_THREADS)
  list (APPEND SOURCEFILES ${fftw_threads_SOURCE})
endif ()


if (HAVE_SSE2)
  list (APPEND SOURCEFILES ${fftw_dft_simd_sse2_SOURCE} ${fftw_rdft_simd_sse2_SOURCE})
endif ()

if (HAVE_AVX)
  list (APPEND SOURCEFILES ${fftw_dft_simd_avx_SOURCE} ${fftw_rdft_simd_avx_SOURCE})
endif ()

if (HAVE_AVX2)
  list (APPEND SOURCEFILES ${fftw_dft_simd_avx2_SOURCE} ${fftw_rdft_simd_avx2_SOURCE})
endif ()

set (FFTW_VERSION 3.3.7)

set (PREC_SUFFIX)
if (ENABLE_FLOAT)
  set (FFTW_SINGLE TRUE)
  set (BENCHFFT_SINGLE TRUE)
  set (PREC_SUFFIX f)
endif ()

if (ENABLE_LONG_DOUBLE)
  set (FFTW_LDOUBLE TRUE)
  set (BENCHFFT_LDOUBLE TRUE)
  set (PREC_SUFFIX l)
endif ()

if (ENABLE_QUAD_PRECISION)
  set (FFTW_QUAD TRUE)
  set (BENCHFFT_QUAD TRUE)
  set (PREC_SUFFIX q)
endif ()
set (fftw3_lib fftw3${PREC_SUFFIX})

configure_file (cmake.config.h.in config.h @ONLY)
include_directories (${CMAKE_CURRENT_BINARY_DIR})

if (BUILD_SHARED_LIBS)
  add_definitions (-DFFTW_DLL)
endif ()


add_library (${fftw3_lib} ${SOURCEFILES})
if (MSVC)
  target_compile_definitions (${fftw3_lib} PRIVATE /bigobj)
endif ()
if (HAVE_SSE)
  target_compile_options (${fftw3_lib} PRIVATE ${SSE_FLAG})
endif ()
if (HAVE_SSE2)
  target_compile_options (${fftw3_lib} PRIVATE ${SSE2_FLAG})
endif ()
if (HAVE_AVX)
  target_compile_options (${fftw3_lib} PRIVATE ${AVX_FLAG})
endif ()
if (HAVE_AVX2)
  target_compile_options (${fftw3_lib} PRIVATE ${AVX2_FLAG})
endif ()
if (HAVE_FMA)
  target_compile_options (${fftw3_lib} PRIVATE ${FMA_FLAG})
endif ()
if (HAVE_LIBM)
  target_link_libraries (${fftw3_lib} m)
endif ()

set (subtargets ${fftw3_lib})

if (Threads_FOUND)
  if (WITH_COMBINED_THREADS)
    target_link_libraries (${fftw3_lib} ${CMAKE_THREAD_LIBS_INIT})
  else ()
    add_library (${fftw3_lib}_threads ${fftw_threads_SOURCE})
    target_link_libraries (${fftw3_lib}_threads ${fftw3_lib})
    target_link_libraries (${fftw3_lib}_threads ${CMAKE_THREAD_LIBS_INIT})
    list (APPEND subtargets ${fftw3_lib}_threads)
  endif ()
endif ()

if (OPENMP_FOUND)
  add_library (${fftw3_lib}_omp ${fftw_omp_SOURCE})
  target_link_libraries (${fftw3_lib}_omp ${fftw3_lib})
  target_link_libraries (${fftw3_lib}_omp ${CMAKE_THREAD_LIBS_INIT})
  list (APPEND subtargets ${fftw3_lib}_omp)
  target_compile_options (${fftw3_lib}_omp PRIVATE ${OpenMP_C_FLAGS})
endif ()

foreach(subtarget ${subtargets})
  set_target_properties (${subtarget} PROPERTIES SOVERSION 3.5.7 VERSION 3)
  install (TARGETS ${subtarget}
	  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endforeach ()
install(TARGETS ${fftw3_lib}
          EXPORT FFTW3LibraryDepends
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install (FILES api/fftw3.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if (EXISTS api/fftw3.f)
  install (FILES api/fftw3.f DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif ()

if (BUILD_TESTS)

  add_executable (bench ${fftw_libbench2_SOURCE} tests/bench.c tests/hook.c tests/fftw-bench.c)

## fftw3 3.3

=== debian/changelog ===
fftw3 (3.3-1ubuntu1) precise; urgency=low

  * Merge with Debian; remaining changes:
    - Revert the ARM workaround.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Dec 2011 13:21:22 +0100

fftw3 (3.3-1) unstable; urgency=low

  * Team upload.
  * New upstream release
  * Package moved into the Debian Science team (no answer from the previous
    maintainer) and package not maintained.
  * Standards-Version updated to version 3.9.2
  * Vcs-Browser & Vcs-Svn updated
  * lintian brace-expansion-in-debhelper-config-file fixed
  * lintian non-empty-dependency_libs-in-la-file fixed
  * Sync from Ubuntu (Closes: #624285)
  * Switch to dpkg-source 3.0 (quilt) format
  * Provide the debug symbols

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 29 Nov 2011 01:13:21 +0100

fftw3 (3.2.2-1ubuntu3) precise; urgency=low

  * Revert the armel work-around. LP: #841437.

 -- Matthias Klose <doko@ubuntu.com> Sat, 03 Dec 2011 19:23:51 +0100

fftw3 (3.2.2-1ubuntu2) oneiric; urgency=low

  * Work around FTBFS on armel, build some files with -O1. LP: #841437.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Sep 2011 16:18:43 +0200

fftw3 (3.2.2-1ubuntu1) oneiric; urgency=low

  * Rebuild with gfortran-4.6.
  * Configure with --enable-sse --enable-sse2 on amd64. LP: #602586.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Sep 2011 11:19:17 +0200

fftw3 (3.2.2-1) unstable; urgency=low

  * New upstream release
  * Acknowledge non-maintainer upload (closes: #532340, #532301),
    thanks to Cyril Brulebois
  * debian/control
    - add ${misc:Depends}
    - bump Standards-Version to 3.8.3, debhelper to >= 7.0.0
    - span build-depends on multiple lines
    - added Vcs-Bzr and Vcs-Browser fields
  * debian/rules
    - fix bashisms (closes: #535378)
    - only install long double where needed (closes: #540408)
    - use dh_prep
  * debian/compat: bump to 7
  * debian/README.source: add reference to quilt documentation

 -- Paul Brossier <piem@debian.org>  Fri, 30 Oct 2009 15:58:13 +0100

fftw3 (3.2.1-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS on powerpc: stop passing “-maltivec” through CFLAGS in
    debian/rules, thanks to Aurélien Jarno (closes: #532340).
  * Fix FTBFS on GNU/kFreeBSD: improve the detection of POSIX semaphores
    (they can be shared or non-shared, and GNU/kFreeBSD only supports
    the latter), thanks to Petr Salinger (closes: #532301):
     + 04_improve_semaphore_detection.diff

 -- Cyril Brulebois <kibi@debian.org>  Thu, 25 Jun 2009 01:01:04 +0200

fftw3 (3.2.1-2) unstable; urgency=low

  * Move texinfo from Build-Depends-Indep to Build-Depends (closes: #522502)

 -- Paul Brossier <piem@debian.org>  Mon, 06 Apr 2009 15:31:13 +0200

fftw3 (3.2.1-1) unstable; urgency=low

  * New upstream release (closes: #502247, #505842, #515223)
  * Patch from #486046 was included upstream (closes: #486046)
  * Acknowledge non-maintainer upload (closes: #478376)
  * Add build-depends on quilt and switch to patches
  * Switch from gs-gpl to ghostscript (>> 8.63)
  * Add 03_fix_manpages to add missing backslash in manpages
  * Add Homepage and bump Standards-Version to 3.8.1
  * Bump debhelper depends to >=5.0.0
  * Update debian/copyright

 -- Paul Brossier <piem@debian.org>  Fri, 03 Apr 2009 18:00:56 +0200

fftw3 (3.1.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix bashism in debian/rules (Closes: #478376)
  * debian/control:
    - Add ${shlibs:Depends} to binary Depends of libfftw3-dev to satisfy
      libc dependency for test and utility programs.
    - Bump Standards-Version to 3.8.0

 -- Chris Lamb <chris@chris-lamb.co.uk>  Sat, 07 Jun 2008 17:59:46 +0100

fftw3 (3.1.2-3) unstable; urgency=low

  * Rename fftw3{,-dev,-doc} to libfftw3{,-dev,-doc}.
    (closes: #430238, #378444)
  * Add Conflicts/Replaces/Provides to all packages accordingly.
  * Add -$(RM) -rf debian/tmp-long-double to debian/rules:clean 
    (closes: #424261)

 -- Paul Brossier <piem@debian.org>  Fri, 03 Aug 2007 13:33:47 +0200

fftw3 (3.1.2-2) unstable; urgency=low

  * debian/rules, debian/control: switching fortran compiler from g77 to
    gfortran, avoiding dependancies against older gcc binaries. Compatibility
    with g77 compiled libraries should work, since the -ff2c option is used.
    DEB_BUILD_OPTIONS=nog77 can be used to disable backward compatibility.
    Thanks to Steven G. Johnson and Warren Turkal. (closes: #392301)
  * debian/fftw3-doc.doc-base.{fftw3-faq,manual}: add missing Index: line to
    Info and Text formats (closes: #418798)

 -- Paul Brossier <piem@debian.org>  Fri, 13 Apr 2007 11:24:21 +0200

fftw3 (3.1.2-1) unstable; urgency=low

  * New upstream release (closes: #376967)
  * debian/rules: enable altivec optimisations on powerpc (closes: #225959)
  * debian/fftw3-dev: manpages are in usr/share/man/man1
  * fix noopt build option.

 -- Paul Brossier <piem@debian.org>  Thu, 27 Jul 2006 12:13:39 +0200

fftw3 (3.1.1-2) unstable; urgency=low

  * fftw3-dev: use versioned dependancy against fftw3 (= ${Source-version})
    (closes: #372246) instead of '${shlibs:Depends}, pkg-config'

 -- Paul Brossier <piem@debian.org>  Sat,  1 Jul 2006 13:17:24 +0200

fftw3 (3.1.1-1) unstable; urgency=low

  * New upstream release (closes: #350327, #338487, #338501)
  * Add --enable-portable-binary to use -mtune instead of -march
  * Use --with-gcc-arch=G5 / pentium4 on powerpc / i386
  * Updated Standards-Version

 -- Paul Brossier <piem@debian.org>  Wed, 31 May 2006 13:44:05 +0200

fftw3 (3.0.1-14) unstable; urgency=low

  * Fixes in acinclude.m4:
    + bypass all checks for specific architecture flags
    + make gcc flags check even when CFLAGS is set
    + don't add -fomit-frame-pointer to CFLAGS (automatically added
      by -O on machines that supports it)
    + avoid overwriting CFLAGS passed from configure
    + don't compile codelets with -O3

  * Other fixes in source tree:
    + add AC_CANONICAL_HOST to configure.in


=== debian/control ===
Source: fftw3
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Paul Brossier <piem@debian.org>
Build-Depends: debhelper (>=7.0.0),
               gfortran,
               texinfo, quilt
Build-Depends-Indep: transfig, ghostscript (>> 8.63)
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fftw3/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/fftw3/
Homepage: http://fftw.org
Standards-Version: 3.9.2

Package: libfftw3-3
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libfftw3-dev
Provides: fftw3
Replaces: fftw3
Conflicts: fftw3
Description: library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 versions of the fftw libraries in single, double and long double precisions.
 Note that on some architectures double is the same as long double in which
 case there is no long double library.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-dev
Architecture: any
Section: libdevel
Depends: libfftw3-3 (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: fftw3-dev
Replaces: fftw3-dev
Conflicts: fftw3-dev
Description: library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 For documentation, see libfftw3-doc.

Package: libfftw3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libfftw3-3
Provides: fftw3-doc
Replaces: fftw3-doc
Conflicts: fftw3-doc
Description: documentation for fftw version 3
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the documentation for
 the fftw3 library.

Package: libfftw3-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libfftw3-dev (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Library for computing Fast Fourier Transforms - debug symbols
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 For documentation, see libfftw3-doc.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS := -g -Wall

# old configure stuff needs a --target
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  archconfflags := $(archconfflags) --build $(DEB_HOST_GNU_TYPE)
else
  archconfflags := $(archconfflags) --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

#--enable-k7             enable AMD K7 optimizations, including 3dNow! (single precision)
#--enable-sse            enable SSE optimizations (single precision only)
#--enable-sse2           enable SSE2 optimizations (double precision only)
#--enable-altivec        enable Altivec optimizations (single precision only)

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
ifeq ($(ARCHITECTURE), i386)
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
	archconfflags := $(archconfflags) --with-gcc-arch=pentium4
endif
ifeq ($(ARCHITECTURE), amd64)
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
endif
ifeq ($(ARCHITECTURE), amd64)
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
endif
ifeq ($(ARCHITECTURE), m68k)
	#CFLAGS='-g -Wall -O0'
	#archconfflags :=
endif
ifeq ($(ARCHITECTURE), powerpc)
	# altivec detection and compilation broken
	archconfflags_single := --enable-altivec
	archconfflags := $(archconfflags) --with-gcc-arch=G5
	# Disabled (FTBFS, #532340):
	# CFLAGS += -maltivec
endif
endif

ifneq (,$(findstring nog77,$(DEB_BUILD_OPTIONS)))
	archconfflags := $(archconfflags) F77="gfortran" 
else
	archconfflags := $(archconfflags) F77="gfortran -ff2c"
endif

SETCFLAGS := CFLAGS='$(CFLAGS)'

# common configure options
archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-portable-binary

build-arch:
	# single precision
	$(SETCFLAGS) ./configure --enable-single $(archconfflags) $(archconfflags_single)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-single
	#
	# double precision
	$(SETCFLAGS) ./configure $(archconfflags) $(archconfflags_double)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-double
	#
	# long double precision
	# build only on architectures where double != long-double
	gcc -o test_long_long-double debian/test_long_long-double.c 
	if ! ./test_long_long-double; then \
		$(SETCFLAGS) ./configure --enable-long-double $(archconfflags) && \
		$(MAKE) && \
		( cd tests ; $(MAKE) smallcheck ) && \
		$(MAKE) install DESTDIR=`pwd`/debian/tmp-long-double; \
	fi
	touch build-arch

build-indep:
	-(cd doc ; $(MAKE) -k clean)
	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
	cd doc/FAQ && $(MAKE) fftw-faq.html fftw-faq.ascii
	cd doc && $(MAKE) && $(MAKE) html
	touch build-indep

build: build-stamp
build-stamp: patch build-arch

clean: clean1st unpatch
clean1st:
	dh_testdir
	dh_testroot
	rm -f build-arch build-indep
	(cd doc ; [ ! -f Makefile ] || $(MAKE) -k clean)
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
	-rm -f tools/*-wisdom.1 tools/fftw*-wisdom
	-rm -f *.la threads/*.la *.pc
	-rm -f test_long_long-double
	-rm -f config.cache config.status config.log
	-rm -rf debian/tmp-single debian/tmp-double debian/tmp-long-double
	chmod -R g-s .
	dh_clean

binary-indep: build-indep
	# build fftw3-doc
	dh_prep -i
	dh_testdir
	dh_testroot
	dh_installdocs -i README NEWS
	dh_installinfo -i
	dh_installchangelogs -i ChangeLog
	dh_compress -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build-arch
	# build fftw3
	dh_prep -a
	dh_installdocs -a README NEWS
	dh_installchangelogs -a ChangeLog
	dh_installexamples -a
	dh_installdirs -a
	dh_install -a --sourcedir=debian/tmp-single
	dh_install -a --sourcedir=debian/tmp-double
	if ! ./test_long_long-double; then \
		dh_install -a --sourcedir=debian/tmp-long-double; \
	fi
	dh_installman -a
	dh_strip --dbg-package=libfftw3-dbg -a
	dh_compress -a -X.c -X.pl -X.am -X.in
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean

## fftw3 3.3.1

=== debian/changelog ===
fftw3 (3.3.1-3) experimental; urgency=low

  * Add the multiarch support. Thanks to Julian Taylor for the patch
    (Closes: #664155)
  * Fix some various silly and useless conflicts (Closes: #664156)
  
 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 15 Mar 2012 23:08:45 +0100

fftw3 (3.3.1-1) experimental; urgency=low

  * Team upload.
  * New upstream release (Closes: #661867)
  * Enable the MPI version of fftw (Closes: #528680)
  * Standards-Version to version 3.9.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Mar 2012 14:19:28 +0100

=== debian/control ===
--- 
+++ 
@@ -4,23 +4,43 @@
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Paul Brossier <piem@debian.org>
 Build-Depends: debhelper (>=7.0.0),
+               dpkg (>= 1.16.0),
                gfortran,
-               texinfo, quilt
+               texinfo, quilt, mpi-default-dev
 Build-Depends-Indep: transfig, ghostscript (>> 8.63)
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fftw3/
 Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/fftw3/
 Homepage: http://fftw.org
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 
 Package: libfftw3-3
 Architecture: any
 Section: libs
+Pre-Depends: multiarch-support
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: libfftw3-dev
 Provides: fftw3
 Replaces: fftw3
 Conflicts: fftw3
-Description: library for computing Fast Fourier Transforms
+Multi-Arch: same
+Description: Library for computing Fast Fourier Transforms
+ The FFTW library computes Fast Fourier Transforms (FFT) in one or more
+ dimensions. It is extremely fast. This package contains the shared library
+ versions of the fftw libraries in single, double and long double precisions.
+ Note that on some architectures double is the same as long double in which
+ case there is no long double library.
+ .
+ To get the static library and the header files, you need to install
+ libfftw3-dev. For documentation, see libfftw3-doc.
+
+Package: libfftw3-mpi-3
+Architecture: any
+Section: libs
+Pre-Depends: multiarch-support
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: libfftw3-mpi-dev
+Multi-Arch: same
+Description: MPI Library for computing Fast Fourier Transforms
  The FFTW library computes Fast Fourier Transforms (FFT) in one or more
  dimensions. It is extremely fast. This package contains the shared library
  versions of the fftw libraries in single, double and long double precisions.
@@ -37,7 +57,18 @@
 Provides: fftw3-dev
 Replaces: fftw3-dev
 Conflicts: fftw3-dev
-Description: library for computing Fast Fourier Transforms
+Description: Library for computing Fast Fourier Transforms
+ The FFTW library computes Fast Fourier Transforms (FFT) in one or more
+ dimensions. It is extremely fast. This package contains the statically linked
+ library, header files and test programs.
+ .
+ For documentation, see libfftw3-doc.
+
+Package: libfftw3-mpi-dev
+Architecture: any
+Section: libdevel
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: MPI Library for computing Fast Fourier Transforms
  The FFTW library computes Fast Fourier Transforms (FFT) in one or more
  dimensions. It is extremely fast. This package contains the statically linked
  library, header files and test programs.
@@ -52,7 +83,7 @@
 Provides: fftw3-doc
 Replaces: fftw3-doc
 Conflicts: fftw3-doc
-Description: documentation for fftw version 3
+Description: Documentation for fftw version 3
  The FFTW library computes Fast Fourier Transforms (FFT) in one or more
  dimensions. It is extremely fast. This package contains the documentation for
  the fftw3 library.
@@ -67,4 +98,6 @@
  dimensions. It is extremely fast. This package contains the statically linked
  library, header files and test programs.
  .
+ This package contains debug packages for both serial and MPI versions.
+ .
  For documentation, see libfftw3-doc.

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 CFLAGS := -g -Wall
 
@@ -59,7 +60,7 @@
 SETCFLAGS := CFLAGS='$(CFLAGS)'
 
 # common configure options
-archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-portable-binary
+archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-portable-binary --enable-mpi --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 
 build-arch:
 	# single precision
@@ -70,6 +71,11 @@
 	#
 	# double precision
 	$(SETCFLAGS) ./configure $(archconfflags) $(archconfflags_double)
+ifneq (,$(filter $(ARCHITECTURE), armel armhf))
+	# work around LP: #841437
+	$(MAKE) -C rdft/scalar/r2cf r2cf_64.lo CFLAGS='-g -Wall -O1 -pthread'
+	$(MAKE) -C rdft/scalar/r2cb r2cb_64.lo CFLAGS='-g -Wall -O1 -pthread'
+endif
 	$(MAKE)
 	( cd tests ; $(MAKE) smallcheck )
 	$(MAKE) install DESTDIR=`pwd`/debian/tmp-double
@@ -137,6 +143,9 @@
 	if ! ./test_long_long-double; then \
 		dh_install -a --sourcedir=debian/tmp-long-double; \
 	fi
+	rm debian/libfftw3-3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi* debian/libfftw3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi* debian/libfftw3-dev/usr/include/*mpi*
+
+
 	dh_installman -a
 	dh_strip --dbg-package=libfftw3-dbg -a
 	dh_compress -a -X.c -X.pl -X.am -X.in

## fftw3 3.3.2

=== debian/changelog ===
fftw3 (3.3.2-3.1ubuntu1) quantal; urgency=low

  * merge with Debian, remaining changes:
    - remove the mpi packages not suitable for main
    - add debian/source/extended-diff-ignore to ignore generated files
    - add hardening flags to long long test so build log check does not complain

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sat, 18 Aug 2012 16:29:47 +0200

fftw3 (3.3.2-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/rules: Use xz compression for binary packages.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 05 Aug 2012 16:38:56 +0200

fftw3 (3.3.2-3ubuntu1) quantal; urgency=low

  * merge with Debian (LP: #1007259, #781726)
  * remove the mpi packages not suitable for main
  * add debian/source/extended-diff-ignore to ignore generated files
  * add hardening flags to long long test so build log check does not complain

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Thu, 21 Jun 2012 23:07:47 +0200

fftw3 (3.3.2-3) unstable; urgency=low

  * disable neon for armel, it has no fpu

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sun, 10 Jun 2012 12:02:19 +0200

fftw3 (3.3.2-2) unstable; urgency=low

  * remove workaround for a transient gcc failure on arm (LP: #841437)
  * enable runtime detected neon extension support on arm and armhf
  * enable sse extensions for kfreebsd (Closes: #674760)
    avx not supported yet 
  * drop 04_improve_semaphore_detection.diff
    semaphores are not shared anymore since 3.2.2
  * enable hardening options
  * move packaging to git

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sat, 09 Jun 2012 22:44:57 +0200

fftw3 (3.3.2-1) unstable; urgency=low

  * Team upload to unstable
  * New upstream release
  * enable avx on i386 too, detected at runtime
  * move wisdom tools to libfftw3-bin, make libfftw3-dev multiarch same
  * revert split into -mt package
    package size gain is negiglible compared to main library
  * drop debian/patches/fix-links.patch applied upstream
  * remove empty directories from libfftw3-dev
  * respect DEB_BUILD_OPTIONS parallel
  * add myself to Uploaders

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Fri, 18 May 2012 17:09:50 +0200

fftw3 (3.3.1-4) experimental; urgency=low

  * Team upload.
  * enable avx on amd64, detected at runtime
  * debian/patches/fix-links.patch:
    - Fix links of the thread and mpi library (Closes: #664531)
  * debian/rules:
    - pass MPILIBS=mpicc --showme:link to configure to ensure correct
      mpi linkage
    - remove rpath from mpi libs with chrpath, add build-depend on it
    - remove unneeded quilt.make and the build-depend
  * wrap-and-sort debian directory
  * minor package description cleanup
  * stop using removed --enable-portable-binary which is now default
  * Build the openmp and pthread libraries into libfftw3-mt{3,dev}
  * rename libfftw3-mpi-3 to libfftw3-mpi3 to conform to naming rules

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Fri, 23 Mar 2012 00:26:17 +0100

=== debian/control ===
Source: fftw3
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Paul Brossier <piem@debian.org>,
           Julian Taylor <jtaylor.debian@googlemail.com>
Build-Depends: chrpath,
               debhelper (>=7.0.0),
               dpkg (>= 1.16.0),
               gfortran,
               texinfo
Build-Depends-Indep: ghostscript (>> 8.63), transfig
Vcs-Git: git://git.debian.org/git/debian-science/packages/fftw3.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/fftw3.git
Homepage: http://fftw.org
Standards-Version: 3.9.3
DM-Upload-Allowed: yes

Package: libfftw3-3
Architecture: any
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Provides: fftw3
Replaces: fftw3
Conflicts: fftw3
Multi-Arch: same
Description: Library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 versions of the fftw libraries in single, double and long double precisions.
 Note that on some architectures double is the same as long double in which
 case there is no long double library.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Replaces: libfftw3-dev (<< 3.3.2-1)
Breaks: libfftw3-dev (<< 3.3.2-1)
Description: Library for computing Fast Fourier Transforms - Tools
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 versions of the fftw libraries in single, double and long double precisions.
 Note that on some architectures double is the same as long double in which
 case there is no long double library.
 .
 This package contains the wisdom management tools.

Package: libfftw3-dev
Architecture: any
Section: libdevel
Depends: libfftw3-3 (=${binary:Version}),
         libfftw3-bin (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: fftw3-dev
Replaces: fftw3-dev
Conflicts: fftw3-dev
Multi-Arch: same
Description: Library for computing Fast Fourier Transforms - development
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains the header files and static libraries.
 For documentation, see libfftw3-doc.

Package: libfftw3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libfftw3-3
Provides: fftw3-doc
Replaces: fftw3-doc
Conflicts: fftw3-doc
Description: Documentation for fftw version 3
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the documentation for
 the fftw3 library.

Package: libfftw3-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libfftw3-dev (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Library for computing Fast Fourier Transforms - debug symbols
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains debug packages.
 .
 For documentation, see libfftw3-doc.

=== debian/rules ===
#!/usr/bin/make -f

ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# old configure stuff needs a --target
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  archconfflags := $(archconfflags) --build $(DEB_HOST_GNU_TYPE)
else
  archconfflags := $(archconfflags) --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

#--enable-k7             enable AMD K7 optimizations, including 3dNow! (single precision)
#--enable-sse            enable SSE optimizations (single precision only)
#--enable-sse2           enable SSE2 optimizations (double precision only)
#--enable-altivec        enable Altivec optimizations (single precision only)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
ifeq ($(ARCHITECTURE), i386)
	archconfflags_single := --enable-sse --enable-avx
	archconfflags_double := --enable-sse2 --enable-avx
	archconfflags := $(archconfflags) --with-gcc-arch=pentium4
endif
ifeq ($(ARCHITECTURE), amd64)
	archconfflags_single := --enable-sse --enable-avx
	archconfflags_double := --enable-sse2 --enable-avx
endif
# no avx support in debian yet see #674760
ifneq (,$(filter $(ARCHITECTURE), kfreebsd-i386 kfreebsd-amd64))
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
endif
ifeq ($(ARCHITECTURE), powerpc)
	archconfflags_single := --enable-altivec
	archconfflags := $(archconfflags) --with-gcc-arch=G5
endif
ifeq ($(ARCHITECTURE), armhf)
	archconfflags_single := --enable-neon
endif
endif

ifneq (,$(findstring nog77,$(DEB_BUILD_OPTIONS)))
	archconfflags := $(archconfflags) F77="gfortran" 
else
	archconfflags := $(archconfflags) F77="gfortran -ff2c"
endif

SETCFLAGS := CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' CPPFLAGS='$(CPPFLAGS)'

# common configure options
archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

build-arch:
	# single precision
	$(SETCFLAGS) ./configure --enable-single $(archconfflags) $(archconfflags_single)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-single
	#
	# double precision
	$(SETCFLAGS) ./configure $(archconfflags) $(archconfflags_double)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-double
	#
	# long double precision
	# build only on architectures where double != long-double
	# flags added so build log checks don't report missing hardening flags
	gcc $(CFLAGS) $(LDFLAGS) $(CPPFLAGS) -o test_long_long-double debian/test_long_long-double.c
	if ! ./test_long_long-double; then \
		$(SETCFLAGS) ./configure --enable-long-double $(archconfflags) && \
		$(MAKE) && \
		( cd tests ; $(MAKE) smallcheck ) && \
		$(MAKE) install DESTDIR=`pwd`/debian/tmp-long-double; \
	fi
	touch build-arch

build-indep:
	-(cd doc ; $(MAKE) -k clean)
	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
	cd doc/FAQ && $(MAKE) fftw-faq.html fftw-faq.ascii
	cd doc && $(MAKE) && $(MAKE) html
	touch build-indep

build: build-stamp
build-stamp: build-arch

clean: clean1st
clean1st:
	dh_testdir
	dh_testroot
	rm -f build-arch build-indep
	(cd doc ; [ ! -f Makefile ] || $(MAKE) -k clean)
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f *.la threads/*.la *.pc
	-rm -f test_long_long-double
	-rm -f config.cache config.status config.log
	-rm -rf debian/tmp-single debian/tmp-double debian/tmp-long-double
	chmod -R g-s .
	dh_clean

binary-indep: build-indep
	# build fftw3-doc
	dh_prep -i
	dh_testdir
	dh_testroot
	dh_installdocs -i README NEWS
	dh_installinfo -i
	dh_installchangelogs -i ChangeLog
	dh_compress -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

binary-arch: build-arch
	# build fftw3
	dh_prep -a
	dh_installdocs -a README NEWS
	dh_installchangelogs -a ChangeLog
	dh_installexamples -a
	dh_installdirs -a
	dh_install -a --sourcedir=debian/tmp-single
	dh_install -a --sourcedir=debian/tmp-double
	if ! ./test_long_long-double; then \
		dh_install -a --sourcedir=debian/tmp-long-double; \
	fi

	find $(CURDIR)/debian/libfftw3-dev -type d -empty -delete

	dh_installman -a
	dh_strip --dbg-package=libfftw3-dbg -a
	dh_compress -a -X.c -X.pl -X.am -X.in
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean
